# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in C:\Users\User\AppData\Local\Android\sdk/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

#############################################
#
# 通用參數設定
#
#############################################

# Code混淆壓縮比, 0~7
-optimizationpasses 5

# 混合不使用大小寫混合, 混合後產生小寫class name
-dontusemixedcaseclassnames

# 指定不去忽略非公共庫的Class
-dontskipnonpubliclibraryclasses

# 不做預校驗，preverify是proguard的四個步驟之一，Android不需要preverify，去掉這一步能夠加快混淆速度。
-dontpreverify

# 保留Annotation不混淆
-keepattributes *Annotation*,InnerClasses

# 避免混淆簽章
-keepattributes Signature

# 拋出異常時保​​留代碼行號
#-keepattributes SourceFile,LineNumberTable

# 這句話能夠使我們的項目混淆後產生映射文件
# 包含有類名->混淆後類名的映射關係
-verbose

# 指定混淆採用的算法，後面的參數是一個過濾器
# 這個過濾器是谷歌推薦的算法，一般不做更改
#-optimizations !code/simplification/arithmetic,!field/ ,!class/merging/
-optimizations !code/simplification/arithmetic,!code/allocation/variable

-printconfiguration proguard-config-output.txt

-assumenosideeffects class android.util.Log {
  public static *** v(...);
}

-keep class com.unitech.rfidreader.** {
    *;
}

-keep class org.apache.log4j.** {
    *;
}

-keep class android_serialport_api.** {
    *;
}

-dontwarn org.jdom.xpath.**
-dontwarn org.llrp.ltk.util.**