package com.unitech.rfidreader.Listener;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.thingmagic.Gen2;
import com.thingmagic.ReadExceptionListener;
import com.thingmagic.ReadListener;
import com.thingmagic.Reader;
import com.thingmagic.ReaderException;
import com.thingmagic.SerialReader;
import com.thingmagic.SimpleReadPlan;
import com.thingmagic.StatusListener;
import com.thingmagic.TMConstants;
import com.thingmagic.TagData;
import com.thingmagic.TagProtocol;
import com.thingmagic.TagReadData;
import com.unitech.ReaderConnect;
import com.unitech.rfidreader.BuildConfig;
import com.unitech.rfidreader.R;
import com.unitech.rfidreader.ReaderActivity;
import com.unitech.rfidreader.TagRecord;
import com.unitech.util.Beeper;
import com.unitech.util.Configuration;
import com.unitech.util.LoggerUtil;

import java.io.FileInputStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

@SuppressLint("StaticFieldLeak")
public class ServiceListener implements View.OnClickListener {

    private static final String TAG = "ServiceListener";
    private static final int Rapid_Read_Mode = 0;
    private static final int Cycle_Count_Mode = 1;
    private static final int Custom_Mode = 2;

    private static final int BLF_250K = 0;
    private static final int BLF_640K = 1;

    private static final int TARI_25 = 0;
    private static final int TARI_12_5 = 1;
    private static final int TARI_6_25 = 2;

    private static final int Session_S0 = 0;
    private static final int Session_S1 = 1;
    private static final int Session_S2 = 2;
    private static final int Session_S3 = 3;

    private static final int Encoding_FM0 = 0;
    private static final int Encoding_M2 = 1;
    private static final int Encoding_M4 = 2;
    private static final int Encoding_M8 = 3;

    private static final int Target_AB = 0;
    private static final int Target_BA = 1;
    private static final int Target_A = 2;
    private static final int Target_B = 3;

    private static final int AntennaOnTimeMax = 1000;
    private static final int AntennaOffTimeMin = 100;


    private static LinearLayout readcontrollayout;
    private static Button readButton = null;
    private static Button connectButton = null;
    private static TextView searchResultCount = null;
    private static TextView totalTagCountView = null;
    private static TextView avgReadView = null;
    private static TextView readingTimeView = null;
    private static TextView errorMsgView = null;
    private static TextView temperatureView = null;
    private static Spinner powerList = null;
    //----------------------------------------------------------------------------------------------
    private static EditText edt_epc;
    private EditText edt_address;
    private EditText edt_length;
    private EditText edt_data;
    private Spinner spinner_bank;
    private static String EPCtag = "";
    //----------------------------------------------------------------------------------------------
    public static Button btn_default = null;
    private static Spinner spinner_operation_mode = null;
    private static Spinner spinner_baudrate = null;
    private static EditText read_timeout = null;
    private static EditText edit_async_on_time = null;
    private static EditText edit_async_off_time = null;
    private static Spinner spinner_blf = null;
    private static Spinner spinner_tari = null;
    private static Spinner spinner_session = null;
    private static Spinner spinner_tag_encoding = null;
    private static Spinner spinner_target = null;
    private static Spinner spinner_q = null;
    private static Switch switch_fast_search = null;
    private static Button btn_firmware_upgrade = null;
    private static TextView version_app = null;
    private static TextView version_software = null;
    private static TextView version_hardware = null;
    private static TextView version_model = null;
    private static TextView version_productGroup = null;
    private static TextView version_serial = null;
    private static LinearLayout firmware_hint = null;
    private static LinearLayout layout_firmware = null;

    private static ProgressBar progressBar = null;
    private static int redColor = 0xffff0000;
    private static int textColor = 0xff000000;
    private static ReadThread readThread;
    private static TableLayout table;
    private static LayoutInflater inflater;
    private static ArrayList<String> addedEPCRecords = new ArrayList<>();

    private static ConcurrentHashMap<String, TagRecord> epcToReadDataMap = new ConcurrentHashMap<>();
    private static int uniqueRecordCount = 0;
    private static int totalTagCount = 0;
    private static int currentTagCount = 0;
    private static long queryStartTime = 0;
    private static long queryStopTime = 0;

    private static ReaderActivity mReaderActivity;
    private static Timer timer = new Timer();

    private static int crcCount = 0;
    private ToggleButton powerButton;
    private static FileInputStream mFileInputStream;

    private static ReentrantLock readerLock;
    private static ReentrantLock stopLock, switchLock;
    private static Condition stopCondition;
    private ExecutorService executor;
    private static Beeper beeper;

    private static Configuration properties;

    public ServiceListener(ReaderActivity readerActivity) {
        mReaderActivity = readerActivity;
        findAllViewsById();
        beeper = Beeper.getInstance();

        properties = new Configuration(readerActivity.getApplicationContext());

        ShowPreReadOptions();

        if (readerLock == null) readerLock = new ReentrantLock();
        if (switchLock == null) switchLock = new ReentrantLock();
        if (stopLock == null) {
            stopLock = new ReentrantLock();
            stopCondition = stopLock.newCondition();
        }

        executor = Executors.newSingleThreadExecutor();
    }

    private void findAllViewsById() {
        inflater = (LayoutInflater) mReaderActivity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        readButton = (Button) mReaderActivity.findViewById(R.id.btn_scan);
        connectButton = (Button) mReaderActivity.findViewById(R.id.btn_connect);
        searchResultCount = (TextView) mReaderActivity.findViewById(R.id.search_result_view);
        totalTagCountView = (TextView) mReaderActivity.findViewById(R.id.totalTagCount_view);
        avgReadView = mReaderActivity.findViewById(R.id.avg_reads_view);
        readingTimeView = mReaderActivity.findViewById(R.id.reading_time);
        temperatureView = mReaderActivity.findViewById(R.id.temperature);
        errorMsgView = mReaderActivity.findViewById(R.id.error_messages_view);
        progressBar = (ProgressBar) mReaderActivity.findViewById(R.id.progressbar);
        textColor = searchResultCount.getTextColors().getDefaultColor();
        table = (TableLayout) mReaderActivity.findViewById(R.id.tablelayout);

        readcontrollayout = (LinearLayout) mReaderActivity.findViewById(R.id.ReadControlLayout);
        spinner_baudrate = mReaderActivity.readOptions.findViewById(R.id.spinner_baudrate);
        read_timeout = mReaderActivity.readOptions.findViewById(R.id.read_time_value);

        edit_async_on_time = mReaderActivity.readOptions.findViewById(R.id.edit_async_on_time);
        edit_async_on_time.setOnFocusChangeListener(asyncOnTimeFocusChangeListener);

        edit_async_off_time = mReaderActivity.readOptions.findViewById(R.id.edit_async_off_time);
        edit_async_off_time.setOnFocusChangeListener(asyncOffTimeFocusChangeListener);

        spinner_blf = mReaderActivity.readOptions.findViewById(R.id.spinner_blf);
        spinner_tari = mReaderActivity.readOptions.findViewById(R.id.spinner_tari);
        spinner_session = mReaderActivity.readOptions.findViewById(R.id.spinner_session);
        spinner_tag_encoding = mReaderActivity.readOptions.findViewById(R.id.spinner_tag_encoding);
        spinner_target = mReaderActivity.readOptions.findViewById(R.id.spinner_target);
        spinner_q = mReaderActivity.readOptions.findViewById(R.id.spinner_q);
        switch_fast_search = mReaderActivity.readOptions.findViewById(R.id.switch_fast_search);

        powerList = (Spinner) mReaderActivity.readOptions.findViewById(R.id.antennaPower);

        layout_firmware = mReaderActivity.firmware.findViewById(R.id.layout_firmware);
        version_software = mReaderActivity.firmware.findViewById(R.id.version_software);
        version_hardware = mReaderActivity.firmware.findViewById(R.id.version_hardware);
        version_model = mReaderActivity.firmware.findViewById(R.id.version_model);
        version_productGroup = mReaderActivity.firmware.findViewById(R.id.version_product_group);
        version_serial = mReaderActivity.firmware.findViewById(R.id.version_serial);
        version_app = mReaderActivity.about.findViewById(R.id.txt_app_version);
        version_app.setText(BuildConfig.VERSION_NAME);
        firmware_hint = mReaderActivity.firmware.findViewById(R.id.firmware_hint);

        //------------------------------------------------------------------------------------------
        edt_epc = (EditText) mReaderActivity.findViewById(R.id.edt_epc);
        edt_address = (EditText) mReaderActivity.findViewById(R.id.edt_address);
        edt_length = (EditText) mReaderActivity.findViewById(R.id.edt_length);
        edt_data = (EditText) mReaderActivity.findViewById(R.id.edt_data);
        spinner_bank = (Spinner) mReaderActivity.findViewById(R.id.spinner_bank);

        ArrayAdapter<CharSequence> Bank_Adapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.bank_array, android.R.layout.simple_spinner_item);
        Bank_Adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_bank.setAdapter(Bank_Adapter);

        powerButton = mReaderActivity.findViewById(R.id.btn_power);

        btn_default = mReaderActivity.readOptions.findViewById(R.id.btn_default);
        btn_default.setOnClickListener(onBtn_default);

        spinner_operation_mode = mReaderActivity.readOptions.findViewById(R.id.spinner_operation_mode);

        ArrayAdapter<CharSequence> operationMode_Adapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.operation_mode_array, android.R.layout.simple_spinner_item);
        Bank_Adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_operation_mode.setAdapter(operationMode_Adapter);
        spinner_operation_mode.setOnItemSelectedListener(operationModeSelectedListerner);
        spinner_operation_mode.setSelection(Cycle_Count_Mode);

        ArrayAdapter<CharSequence> baudAdapter = ArrayAdapter.createFromResource(mReaderActivity,
                R.array.baudrate_array, android.R.layout.simple_spinner_item);
        baudAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_baudrate.setAdapter(baudAdapter);
        spinner_baudrate.setOnItemSelectedListener(baudrateSelectedListener);
        spinner_baudrate.setSelection(2);

        // New params
        ArrayAdapter<CharSequence> blfAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.backscatter_link_frequency_array, android.R.layout.simple_spinner_item);
        blfAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_blf.setAdapter(blfAdapter);
        spinner_blf.setOnItemSelectedListener(blfSelectedListener);

        ArrayAdapter<CharSequence> tariAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.tari_array, android.R.layout.simple_spinner_item);
        tariAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_tari.setAdapter(tariAdapter);

        ArrayAdapter<CharSequence> sessionAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.session_array, android.R.layout.simple_spinner_item);
        sessionAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_session.setAdapter(sessionAdapter);

        ArrayAdapter<CharSequence> tagEncodingAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.tag_encoding_array, android.R.layout.simple_spinner_item);
        tagEncodingAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_tag_encoding.setAdapter(tagEncodingAdapter);

        ArrayAdapter<CharSequence> targetAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.target_array, android.R.layout.simple_spinner_item);
        targetAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_target.setAdapter(targetAdapter);

        ArrayAdapter<CharSequence> qAdapter = ArrayAdapter.createFromResource(mReaderActivity, R.array.target_q, android.R.layout.simple_spinner_item);
        qAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner_q.setAdapter(qAdapter);
        //------------------------------------------------------------------------------------------
    }

    @Override
    public void onClick(View arg0) {
        try {
            if (readButton.getText().equals(mReaderActivity.getResources().getString(R.string.stop_reading))) {
                stopReading();
            } else if (readButton.getText().equals(mReaderActivity.getResources().getString(R.string.start_reading))) {
                startReading();
            }
        } catch (Exception ex) {
            LoggerUtil.error(TAG, "Exception", ex);
        }
    }

    public void startReading() {
        if (readThread != null && (ReadThread.isReading() || ReadThread.isRunning())) {
            return;
        }
        LoggerUtil.debug(TAG, "Trigger start reading");
        switchReading(true);
    }

    public void stopReading() {
        if (readThread != null && !ReadThread.isReading()) {
            return;
        }
        switchReading(false);
    }

    private void switchReading(boolean enable) {
        if (!switchLock.tryLock()) {
            LoggerUtil.debug(TAG, "Switch lock is been locked");
            return;
        }
        if (enable && !isReading()) {
            if (readThread != null && ReadThread.isRunning()) {
                LoggerUtil.warn(TAG, "Read thread is still working, starting cancel.");
                return;
            }
            readButton.setText(mReaderActivity.getResources().getString(R.string.stop_reading));

            clearTagRecords();
            readThread = new ReadThread(mReaderActivity.reader, "asyncRead");
            readThread.execute();
        } else if (!enable && !stopLock.isLocked()) {
//            stopLock.lock();
//            readThread.setReading(false);
//            readButton.setText(mReaderActivity.getResources().getString(R.string.stopping));
//            readButton.setClickable(false);
//            readButton.setEnabled(false);
//            stopLock.unlock();
            executor.submit(runnableStopReading);
        }
        switchLock.unlock();
    }

    private Runnable runnableStopReading = new Runnable() {
        @Override
        public void run() {
            if (isReading() && stopLock.tryLock()) {
                try {
                    LoggerUtil.debug(TAG, "Trigger stop reading");
                    readThread.setReading(false);
                    mReaderActivity.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            readButton.setText(mReaderActivity.getResources().getString(R.string.stopping));
                            readButton.setClickable(false);
                            readButton.setEnabled(false);
                        }
                    });
                    stopCondition.await(5, TimeUnit.SECONDS);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                stopLock.unlock();
            }
        }
    };

    public synchronized boolean isReading() {
        if (readThread != null) {
            return ReadThread.isReading();
        } else {
            return false;
        }
    }

    public OnClickListener clearListener = new OnClickListener() {

        @Override
        public void onClick(View v) {
            if (mReaderActivity.checkScanService.isChecked()) {
                mReaderActivity.clearBarcodeText();
            } else {
                clearTagRecords();
            }
        }
    };
    //---------------------------------------------------------------------------------------------

    public OnClickListener btn_RFID_write = new OnClickListener() {
        @Override
        public void onClick(View v) {
            try {
                OpenRFIDPower(3500, 600);
                setParamToReader("/reader/tagop/antenna", 1);

                String strData = edt_data.getText().toString().trim().toLowerCase();

                if (String.valueOf(edt_address.getText()) != null && !(String.valueOf(edt_address.getText()).equals(""))
                        && String.valueOf(edt_length.getText()) != null && !String.valueOf(edt_length.getText()).equals("")) {
                    int address = Integer.valueOf(String.valueOf(edt_address.getText()));
                    byte length = Integer.valueOf(String.valueOf(edt_length.getText())).byteValue();

                    if (strData.length() == length * 4) {
                        if (address >= 0) {
                            TagData target = new TagData(String.valueOf(edt_epc.getText()));
                            Gen2.WriteData tagWrite = new Gen2.WriteData(Gen2.Bank.getBank(getBank()), address, toShorts(strData));
                            long startTime = System.currentTimeMillis();
                            Object objRet = mReaderActivity.reader.executeTagOp(tagWrite, target);
//                            System.out.println(objRet);
                            long duration = System.currentTimeMillis() - startTime;
                            String msg = String.format("Write success in %d ms", duration);
                            Toast.makeText(mReaderActivity, msg, Toast.LENGTH_SHORT).show();
                            LoggerUtil.info(TAG, msg);
                        }
                    } else {
                        Toast.makeText(mReaderActivity, String.format("Please input a %d length data", length * 4), Toast.LENGTH_SHORT).show();
                    }
                } else {
                    Toast.makeText(mReaderActivity, "Please input data !!!", Toast.LENGTH_SHORT).show();
                }
            } catch (Exception ex) {
                LoggerUtil.error(TAG, "Exception", ex);
                Toast.makeText(mReaderActivity, "Write fail", Toast.LENGTH_SHORT).show();
            }
        }
    };

    public OnClickListener btn_RFID_read = new OnClickListener() {
        @Override
        public void onClick(View v) {
            try {
                OpenRFIDPower(2000, 600);
                setParamToReader("/reader/tagop/antenna", 1);

                String strEPC = String.valueOf(edt_epc.getText());
                TagData target = new TagData(strEPC);

                if (String.valueOf(edt_address.getText()) != null && !(String.valueOf(edt_address.getText()).equals("")) && String.valueOf(edt_length.getText()) != null && !String.valueOf(edt_length.getText()).equals("")) {
                    int address = Integer.valueOf(String.valueOf(edt_address.getText()));
                    byte length = Integer.valueOf(String.valueOf(edt_length.getText())).byteValue();

                    if (address >= 0 && length > 0) {
                        Gen2.ReadData tagRead = new Gen2.ReadData(Gen2.Bank.getBank(getBank()), address, length);
                        long startTime = System.currentTimeMillis();
                        short[] data = (short[]) mReaderActivity.reader.executeTagOp(tagRead, target);
                        long duration = System.currentTimeMillis() - startTime;
                        StringBuilder str = new StringBuilder();
                        for (short aData : data) {
                            String temp = Integer.toHexString(aData & 0xffff);
                            while (temp.length() < 4) {
                                StringBuilder sb = new StringBuilder();
                                temp = sb.append("0").append(temp).toString();
                            }
                            str.append(temp);
                        }
                        edt_data.setText(str.toString().toUpperCase());
                        String msg = String.format("Read success in %d ms", duration);
                        Toast.makeText(mReaderActivity, msg, Toast.LENGTH_SHORT).show();
                        LoggerUtil.info(TAG, msg);
                    } else {
                        Toast.makeText(mReaderActivity, "Please input data !!!", Toast.LENGTH_SHORT).show();
                    }
                } else {
                    Toast.makeText(mReaderActivity, "Please input data !!!", Toast.LENGTH_SHORT).show();
                }
            } catch (Exception ex) {
                LoggerUtil.error(TAG, "Exception", ex);
                Toast.makeText(mReaderActivity, "Read fail", Toast.LENGTH_SHORT).show();
            }
        }
    };

    public static void setRapidRead() {

        LoggerUtil.debug(TAG, "Set Profile Rapid Read");
        powerList.setSelection(16);

        read_timeout.setText(R.string.DefaultTime);

        edit_async_on_time.setText("1000");
        edit_async_off_time.setText("0");

        spinner_blf.setSelection(BLF_640K);
        spinner_tari.setSelection(TARI_6_25);
        spinner_session.setSelection(Session_S0);
        spinner_tag_encoding.setSelection(Encoding_FM0);
        spinner_target.setSelection(Target_A);
        spinner_q.setSelection(0);
        switch_fast_search.setChecked(false);

        lockReaderSetting(false);
    }

    public static OnClickListener onBtn_default = new OnClickListener() {
        @Override
        public void onClick(View v) {
            LoggerUtil.debug(TAG, "Set Default Profile(Cycle Count)");

            spinner_operation_mode.setSelection(Cycle_Count_Mode);

            powerList.setSelection(20);

            read_timeout.setText(R.string.DefaultTime);

            edit_async_on_time.setText(R.string.DefaultAntennaOnTime);
            edit_async_off_time.setText(R.string.DefaultAntennaOffTime);

            spinner_blf.setSelection(BLF_250K);
            spinner_tari.setSelection(TARI_25);
            spinner_session.setSelection(Session_S1);
            spinner_tag_encoding.setSelection(Encoding_M8);
            spinner_target.setSelection(Target_A);
            spinner_q.setSelection(0);
            switch_fast_search.setChecked(false);

            lockReaderSetting(false);
        }
    };


    private static AdapterView.OnItemSelectedListener baudrateSelectedListener = new AdapterView.OnItemSelectedListener() {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
            switch (position) {
                case 0:
                    ReaderConnect.setBaudrate(115200);
                    break;
                case 1:
                    ReaderConnect.setBaudrate(230400);
                    break;
                default:
                case 2:
                    ReaderConnect.setBaudrate(460800);
                    break;
                case 3:
                    ReaderConnect.setBaudrate(921600);
                    break;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    };

    private static AdapterView.OnItemSelectedListener operationModeSelectedListerner = new AdapterView.OnItemSelectedListener() {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
            switch (position) {
                case Rapid_Read_Mode:
                    setRapidRead();
                    break;
                case Cycle_Count_Mode:
                    btn_default.performClick();
                    break;
                case Custom_Mode:
                    showCustomReadOptions();
                    lockReaderSetting(true);
                    break;

            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    };

    private static AdapterView.OnItemSelectedListener blfSelectedListener = new AdapterView.OnItemSelectedListener() {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
            switch (position) {
                case BLF_250K:
                    if (spinner_operation_mode.getSelectedItemPosition() == Custom_Mode) {
                        spinner_tari.setEnabled(true);
                    }
                    break;
                case BLF_640K:
                    if (spinner_operation_mode.getSelectedItemPosition() == Custom_Mode) {
                        spinner_tari.setSelection(TARI_6_25);
                        spinner_tari.setEnabled(false);
                    }
                    break;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    };

    private static View.OnFocusChangeListener asyncOnTimeFocusChangeListener = new View.OnFocusChangeListener(){
        @Override
        public void onFocusChange(View v, boolean hasFocus) {
            if (!hasFocus)
            {
                if (Integer.parseInt(edit_async_on_time.getText().toString()) > AntennaOnTimeMax) {
                    Log.d(TAG, "Change OnTime to " + R.string.antennaOnTimeMax);
                    edit_async_on_time.setText(R.string.antennaOnTimeMax);
                }
            }
        }
    };

    private static View.OnFocusChangeListener asyncOffTimeFocusChangeListener = new View.OnFocusChangeListener(){
        @Override
        public void onFocusChange(View v, boolean hasFocus) {
            if (!hasFocus)
            {
                if (Integer.parseInt(edit_async_off_time.getText().toString()) < AntennaOffTimeMin) {
                    Log.d(TAG, "Change OffTime to " + R.string.antennaOffTimeMin);
                    edit_async_off_time.setText(R.string.antennaOffTimeMin);
                }
            }
        }
    };

    private static void lockReaderSetting(boolean enable) {
        read_timeout.setEnabled(enable);
        edit_async_on_time.setEnabled(enable);
        edit_async_off_time.setEnabled(enable);
        powerList.setEnabled(enable);
        spinner_blf.setEnabled(enable);

        if (spinner_operation_mode.getSelectedItemPosition() == Custom_Mode && spinner_blf.getSelectedItemPosition() != BLF_640K)
            spinner_tari.setEnabled(true);
        else
            spinner_tari.setEnabled(false);

        spinner_session.setEnabled(enable);
        spinner_tag_encoding.setEnabled(enable);
        spinner_target.setEnabled(enable);
        spinner_q.setEnabled(enable);
        switch_fast_search.setEnabled(enable);

        if (enable) {
            if (Integer.parseInt(edit_async_off_time.getText().toString()) < AntennaOffTimeMin) {
                Log.d(TAG, "Change OffTime to " + R.string.antennaOffTimeMin);
                edit_async_off_time.setText(R.string.antennaOffTimeMin);
            }
        }
    }

    private int getBank() {
        int temp;
        switch (spinner_bank.getSelectedItem().toString()) {
            case "RESERVED":
                temp = 0;
                break;
            case "EPC":
                temp = 1;
                break;
            case "TID":
                temp = 2;
                break;
            case "USER":
                temp = 3;
                break;
            default:
                temp = -1;
                break;
        }
        return temp;
    }

    public static void loadDefaultParams(final Reader reader) {
        mReaderActivity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                try {
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_BAUDRATE, reader.paramGet(TMConstants.TMR_PARAM_BAUDRATE).toString()));
                    switch ((Integer) reader.paramGet(TMConstants.TMR_PARAM_BAUDRATE)) {
                        case 115200:
                            spinner_baudrate.setSelection(0);
                            break;
                        case 230400:
                            spinner_baudrate.setSelection(1);
                            break;
                        default:
                        case 460800:
                            spinner_baudrate.setSelection(2);
                            break;
                        case 921600:
                            spinner_baudrate.setSelection(3);
                            break;
                    }
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_BLF, reader.paramGet(TMConstants.TMR_PARAM_GEN2_BLF).toString()));
                    switch ((Gen2.LinkFrequency) reader.paramGet(TMConstants.TMR_PARAM_GEN2_BLF)) {
                        default:
                        case LINK250KHZ:
                            spinner_blf.setSelection(BLF_250K);
                            break;
                        case LINK640KHZ:
                            spinner_blf.setSelection(BLF_640K);
                            break;
                    }
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_TARI, reader.paramGet(TMConstants.TMR_PARAM_GEN2_TARI).toString()));
                    switch ((Gen2.Tari) reader.paramGet(TMConstants.TMR_PARAM_GEN2_TARI)) {
                        default:
                        case TARI_25US:
                            spinner_tari.setSelection(TARI_25);
                            break;
                        case TARI_12_5US:
                            spinner_tari.setSelection(TARI_12_5);
                            break;
                        case TARI_6_25US:
                            spinner_tari.setSelection(TARI_6_25);
                            break;
                    }
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_SESSION, reader.paramGet(TMConstants.TMR_PARAM_GEN2_SESSION).toString()));
                    switch ((Gen2.Session) reader.paramGet(TMConstants.TMR_PARAM_GEN2_SESSION)) {
                        default:
                        case S0:
                            spinner_session.setSelection(Session_S0);
                            break;
                        case S1:
                            spinner_session.setSelection(Session_S1);
                            break;
                        case S2:
                            spinner_session.setSelection(Session_S2);
                            break;
                        case S3:
                            spinner_session.setSelection(Session_S3);
                            break;
                    }
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_TAGENCODING, reader.paramGet(TMConstants.TMR_PARAM_GEN2_TAGENCODING).toString()));
                    switch ((Gen2.TagEncoding) reader.paramGet(TMConstants.TMR_PARAM_GEN2_TAGENCODING)) {
                        case FM0:
                            spinner_tag_encoding.setSelection(Encoding_FM0);
                            break;
                        case M2:
                            spinner_tag_encoding.setSelection(Encoding_M2);
                            break;
                        default:
                        case M4:
                            spinner_tag_encoding.setSelection(Encoding_M4);
                            break;
                        case M8:
                            spinner_tag_encoding.setSelection(Encoding_M8);
                            break;
                    }
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_TARGET, reader.paramGet(TMConstants.TMR_PARAM_GEN2_TARGET).toString()));
                    switch ((Gen2.Target) reader.paramGet(TMConstants.TMR_PARAM_GEN2_TARGET)) {
                        case AB:
                            spinner_target.setSelection(Target_AB);
                            break;
                        case BA:
                            spinner_target.setSelection(Target_BA);
                            break;
                        default:
                        case A:
                            spinner_target.setSelection(Target_A);
                            break;
                        case B:
                            spinner_target.setSelection(Target_B);
                            break;
                    }
//                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_REGION_HOPTIME, reader.paramGet(TMConstants.TMR_PARAM_REGION_HOPTIME).toString()));
//                    edit_hop_time.setText(reader.paramGet(TMConstants.TMR_PARAM_REGION_HOPTIME).toString());

                    Gen2.Q q = (Gen2.Q) reader.paramGet(TMConstants.TMR_PARAM_GEN2_Q);
                    LoggerUtil.debug(TAG, String.format("%s is %s", TMConstants.TMR_PARAM_GEN2_Q, q.toString()));
                    if (q instanceof Gen2.DynamicQ) {
                        spinner_q.setSelection(0);
                    } else if (q instanceof Gen2.StaticQ) {
                        spinner_q.setSelection(((Gen2.StaticQ) q).initialQ + 1);
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public static void OpenRFIDPower() {
        int async_on = 150;
        int async_off = 100;
        try {
            async_on = Integer.parseInt(edit_async_on_time.getText().toString());
            async_off = Integer.parseInt(edit_async_off_time.getText().toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
        OpenRFIDPower(async_on, async_off);
    }

    private static void OpenRFIDPower(int nOnTime, int nOffTime) {
        try {
            //region Set antenna power
            int powerLevel = ((int) (powerList.getSelectedItemId()) + 10) * 100;
            setParamToReader("/reader/radio/readPower", powerLevel);
            //endregion

            //region Set read timeout
            int timeout = Integer.parseInt(read_timeout.getText().toString());
            setParamToReader("/reader/commandTimeout", timeout);
            //endregion

            //region Set BLF
            switch ((int) spinner_blf.getSelectedItemId()) {
                default:
                case BLF_250K:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_BLF, Gen2.LinkFrequency.LINK250KHZ);
                    break;
                case BLF_640K:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_BLF, Gen2.LinkFrequency.LINK640KHZ);
                    break;
            }
            //endregion

            //region Set Session
            switch ((int) spinner_session.getSelectedItemId()) {
                default:
                case Session_S0:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_SESSION, Gen2.Session.S0);
                    break;
                case Session_S1:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_SESSION, Gen2.Session.S1);
                    break;
                case Session_S2:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_SESSION, Gen2.Session.S2);
                    break;
                case Session_S3:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_SESSION, Gen2.Session.S3);
                    break;
            }
            //endregion

            //region Set Encoding
            switch ((int) spinner_tag_encoding.getSelectedItemId()) {
                default:
                case Encoding_FM0:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TAGENCODING, Gen2.TagEncoding.FM0);
                    break;
                case Encoding_M2:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TAGENCODING, Gen2.TagEncoding.M2);
                    break;
                case Encoding_M4:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TAGENCODING, Gen2.TagEncoding.M4);
                    break;
                case Encoding_M8:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TAGENCODING, Gen2.TagEncoding.M8);
                    break;
            }
            //endregion

            //region Set Target
            switch ((int) spinner_target.getSelectedItemId()) {
                default:
                case Target_AB:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARGET, Gen2.Target.AB);
                    break;
                case Target_BA:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARGET, Gen2.Target.BA);
                    break;
                case Target_A:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARGET, Gen2.Target.A);
                    break;
                case Target_B:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARGET, Gen2.Target.B);
                    break;
            }
            //endregion

            //region Set Q
            switch ((int) spinner_q.getSelectedItemId()) {
                default:
                case 0:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_Q, new Gen2.DynamicQ());
                    break;
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                case 16:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_Q, new Gen2.StaticQ((int) spinner_q.getSelectedItemId() - 1));
                    break;
            }
            //endregion

            //region Set TARI value
            switch ((int) spinner_tari.getSelectedItemId()) {
                default:
                case TARI_25:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARI, Gen2.Tari.TARI_25US);
                    break;
                case TARI_12_5:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARI, Gen2.Tari.TARI_12_5US);
                    break;
                case TARI_6_25:
                    setParamToReader(TMConstants.TMR_PARAM_GEN2_TARI, Gen2.Tari.TARI_6_25US);
                    break;
            }
            //endregion

            setParamToReader("/reader/read/asyncOnTime", nOnTime);
            setParamToReader("/reader/read/asyncOffTime", nOffTime);

            setParamToReader(TMConstants.TMR_PARAM_READER_STATUS_TEMPERATURE, true);

            LoggerUtil.debug(TAG, "M6e Micro use antenna 1");

            SimpleReadPlan simplePlan;
            if (switch_fast_search.isChecked()) {
                LoggerUtil.debug(TAG, "Fast search is On");
                simplePlan = new SimpleReadPlan(new int[]{1}, TagProtocol.GEN2, true);
            } else {
                LoggerUtil.debug(TAG, "Fast search is Off");
                simplePlan = new SimpleReadPlan(new int[]{1}, TagProtocol.GEN2, false);
            }
            mReaderActivity.reader.paramSet(TMConstants.TMR_PARAM_READ_PLAN, simplePlan);
        } catch (Exception ex) {
            LoggerUtil.error(TAG, "Exception : ", ex);
        }

    }

    private static boolean setParamToReader(String key, Object value) {
        boolean result = false;
        int retryCount = 0;
        while (!result && retryCount < 3) {
            retryCount++;
            try {
                Object currVal = mReaderActivity.reader.paramGet(key);
                if (currVal.toString().equalsIgnoreCase(value.toString())) {
                    LoggerUtil.debug(TAG, String.format("Param %s already set as %s", key, currVal.toString()));
                    return true;
                }

                mReaderActivity.reader.paramSet(key, value);

                currVal = mReaderActivity.reader.paramGet(key);
                if (currVal.toString().equalsIgnoreCase(value.toString())) {
                    result = true;
                } else {
                    LoggerUtil.debug(TAG, String.format("Check param %s is %s", key, currVal.toString()));
                }
            } catch (Exception e) {
                LoggerUtil.error(TAG, String.format("Exception in param %s", key), e);
            }
            if (result) {
                break;
            } else {
                try {
                    Thread.sleep(200);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
        LoggerUtil.debug(TAG, String.format("Set param %s to %s : %s", key, value.toString(),
                result ? "successfully" : "failed"));
        return result;
    }

    private short[] toShorts(String finalString) {
        StringBuilder ChangeStr = new StringBuilder();
        System.out.println("Length of finalString is " + finalString.length());

        for (int i = 0; i < finalString.length(); i++) {
            ChangeStr.append(finalString.charAt(i));
            if (i % 4 == 3) {
                ChangeStr.append(" ");
            }
        }
        System.out.println("ChangeStr.toString() is " + ChangeStr.toString());
        String[] tabOfShortString = ChangeStr.toString().split(" ");
        int length = tabOfShortString.length;
        System.out.println("Length of float string is " + length);
        short[] shortsArray = new short[length];
        for (int i = 0; i < length; i++) {
            short res = (short) Integer.parseInt(tabOfShortString[i], 16);
            System.out.println("Indice Short Value is " + res);
            shortsArray[i] = res;
        }

        return shortsArray;
    }

    public static void updateSettings() {
        try {
            layout_firmware.setVisibility(View.VISIBLE);
            firmware_hint.setVisibility(View.GONE);

            String software = (String) mReaderActivity.reader.paramGet("/reader/version/software");
            version_software.setText(software);
            String hardware = (String) mReaderActivity.reader.paramGet("/reader/version/hardware");
            version_hardware.setText(hardware);
            String model = (String) mReaderActivity.reader.paramGet("/reader/version/model");
            version_model.setText(model);
            String productGroup = (String) mReaderActivity.reader.paramGet("/reader/version/productGroup");
            version_productGroup.setText(productGroup);
            String serial = (String) mReaderActivity.reader.paramGet("/reader/version/serial");
            version_serial.setText(serial);
            String baudrate = mReaderActivity.reader.paramGet(TMConstants.TMR_PARAM_BAUDRATE).toString();

            LoggerUtil.debug(TAG, String.format("/reader/version/software = %s", software));
            LoggerUtil.debug(TAG, String.format("/reader/version/hardware = %s", hardware));
            LoggerUtil.debug(TAG, String.format("/reader/version/model = %s", model));
            LoggerUtil.debug(TAG, String.format("/reader/version/productGroup = %s", productGroup));
            LoggerUtil.debug(TAG, String.format("/reader/version/serial = %s", serial));
            LoggerUtil.debug(TAG, String.format("%s = %s", TMConstants.TMR_PARAM_BAUDRATE, baudrate));
            LoggerUtil.debug(TAG, String.format("%s = %s", TMConstants.TMR_PARAM_RADIO_TEMPERATURE,
                    mReaderActivity.reader.paramGet(TMConstants.TMR_PARAM_RADIO_TEMPERATURE)));

            ReadThread.setTemperature((Integer) mReaderActivity.reader.paramGet(TMConstants.TMR_PARAM_RADIO_TEMPERATURE));
        } catch (ReaderException e) {
            e.printStackTrace();
        }
    }

    public static void ShowPreReadOptions() {
        LoggerUtil.debug(TAG, "Show Pre-Read Options");
        spinner_operation_mode.setSelection(properties.getOperationMode());

        switch (properties.getOperationMode()) {
            case Rapid_Read_Mode:
                setRapidRead();
                break;
            case Cycle_Count_Mode:
                btn_default.performClick();
                break;
            case Custom_Mode:
                showCustomReadOptions();
                lockReaderSetting(true);
                break;
        }
    }

    private static void showCustomReadOptions()
    {
        LoggerUtil.debug(TAG, "Show Custom Read Options");
        read_timeout.setText(String.valueOf(properties.getReaderTimeout()));

        edit_async_on_time.setText(String.valueOf(properties.getAntennaOnTime()));
        edit_async_off_time.setText(String.valueOf(properties.getAntennaOffTime()));

        powerList.setSelection(properties.getPower());

        spinner_blf.setSelection(properties.getBLF());

        spinner_tari.setSelection(properties.getTARI());

        spinner_session.setSelection(properties.getSession());

        spinner_tag_encoding.setSelection(properties.getEncoding());

        spinner_target.setSelection(properties.getTarget());

        spinner_q.setSelection(properties.getQValue());

        switch_fast_search.setChecked(properties.getFastSearch());
    }

    public static void saveReadOptions()
    {
        LoggerUtil.debug(TAG, "Save Read Options");

        properties.setOperationMode(spinner_operation_mode.getSelectedItemPosition());

        if (spinner_operation_mode.getSelectedItemPosition() != Custom_Mode) {
            return;
        }

        properties.setReaderTimeout(Integer.parseInt(read_timeout.getText().toString()));

        properties.setAntennaOnTime(Integer.parseInt(edit_async_on_time.getText().toString()));
        properties.setAntennaOffTime(Integer.parseInt(edit_async_off_time.getText().toString()));

        properties.setPower(powerList.getSelectedItemPosition());

        properties.setBLF(spinner_blf.getSelectedItemPosition());

        properties.setTARI(spinner_tari.getSelectedItemPosition());

        properties.setSession(spinner_session.getSelectedItemPosition());

        properties.setEncoding(spinner_tag_encoding.getSelectedItemPosition());

        properties.setTarget(spinner_target.getSelectedItemPosition());

        properties.setQValue(spinner_q.getSelectedItemPosition());

        properties.setFastSearch(switch_fast_search.isChecked());
    }

    public static void clearTagRecords() {
        addedEPCRecords.clear();
        epcToReadDataMap.clear();
        table.removeAllViews();
        searchResultCount.setText("");
        totalTagCountView.setText("");
        avgReadView.setText("");
        readingTimeView.setText("");
        temperatureView.setText("");
        uniqueRecordCount = 0;
        totalTagCount = 0;
        queryStartTime = System.currentTimeMillis();
    }

    @SuppressLint("StaticFieldLeak")
    public static class ReadThread extends AsyncTask<Void, Integer, ConcurrentHashMap<String, TagRecord>> {
        private final static DecimalFormat df = new DecimalFormat("#.##");

        private String temp_str = null, avg_str = null;
        private String operation;
        private static boolean exceptionOccur = false;
        private static List<String> exception;
        private static boolean reading = true, running = false;
        private static Reader mReader;
        private static TableRow fullRow = null;
        private static TextView nr = null;
        private static TextView epcValue = null;
        private static TextView rssiView = null;
        private static TextView dataView = null;
        private static TextView countView = null;
        private static boolean isEmbeddedRead = false;
        private static int Temperature = 0;

        private int lastTagCount = 0;
        private int readLoop = 0;

        static ReadExceptionListener exceptionListener = new TagReadExceptionReceiver();
        static ReadListener readListener = new PrintListener();
        static StatusListener statusListener = new ReaderStatusListener();

        ReadThread(Reader reader, String operation) {
            this.operation = operation;
            mReader = reader;
            exception = new ArrayList<>();
        }

        @Override
        protected void onPreExecute() {
            setRunning(true);
            clearTagRecords();
            exception.clear();

            connectButton.setEnabled(false);
            connectButton.setClickable(false);

            readButton.setText(mReaderActivity.getResources().getString(R.string.starting));
            readButton.setClickable(false);
            readButton.setEnabled(false);

            mReaderActivity.disableBarcode();

            searchResultCount.setTextColor(textColor);
            searchResultCount.setText(mReaderActivity.getResources().getString(R.string.reading_tags));
//            progressBar.setVisibility(View.VISIBLE);
            addedEPCRecords = new ArrayList<>();
            epcToReadDataMap = new ConcurrentHashMap<>();
            exceptionOccur = false;
        }

        @Override
        protected ConcurrentHashMap<String, TagRecord> doInBackground(Void... params) {
            try {
                readerLock.lock();
                setReading(true);
                mReaderActivity.runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        readButton.setText(mReaderActivity.getResources().getString(R.string.stop_reading));
                        readButton.setClickable(true);
                        readButton.setEnabled(true);
                    }
                });

                mReader.addReadExceptionListener(exceptionListener);
                mReader.addReadListener(readListener);
                mReader.addStatusListener(statusListener);
                mReader.startReading();
                readerLock.unlock();

                queryStartTime = System.currentTimeMillis();
                queryStopTime = queryStartTime;
                refreshReadRate();
                while (isReading()) {
                    /* Waiting till stop reading button is pressed */
                    Thread.sleep(5);
                }
                LoggerUtil.debug(TAG, "Reading end...");
            } catch (Exception ex) {
                exception.add(ex.getMessage());
                exceptionOccur = true;
                LoggerUtil.error(TAG, "Exception while reading :", ex);
            } finally {
                LoggerUtil.debug(TAG, "ReadThread stopping");
                timer.cancel();
                mReader.removeReadListener(readListener);
                mReader.removeReadExceptionListener(exceptionListener);
                mReader.removeStatusListener(statusListener);
                if (!exceptionOccur) {
                    mReader.stopReading();
                }
                queryStopTime = System.currentTimeMillis();
                LoggerUtil.debug(TAG, "ReadThread stopped");
            }

            return epcToReadDataMap;
        }

        static class PrintListener implements ReadListener {
            public void tagRead(Reader r, final TagReadData tr) {
                readThread.parseTag(tr);
            }
        }

        static class ReaderStatusListener implements StatusListener {

            @Override
            public void statusMessage(Reader reader, SerialReader.StatusReport[] statusReports) {
                if (reader == mReaderActivity.reader) {
                    for (int i = 0; i < statusReports.length; i++) {
                        if (statusReports[i] instanceof SerialReader.TemperatureStatusReport) {
                            LoggerUtil.debug(TAG, statusReports[i].toString());
                            Temperature = ((SerialReader.TemperatureStatusReport) statusReports[i]).getTemperature();

                            if (Temperature > 70) {
                                final String ex = "The module temperature rises above 70°C and App stops reading to protect module. ";
                                LoggerUtil.warn(TAG, String.format("Module exception : %s", ex));
                                readThread.setReading(false);
                                mReaderActivity.runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        AlertDialog deleteAlert = new AlertDialog.Builder(connectButton.getContext()).create();
                                        deleteAlert.setTitle("Module Overheat");
                                        deleteAlert.setMessage(ex);
                                        deleteAlert.show();
                                    }
                                });
                            }

                        } else if (statusReports[i] instanceof SerialReader.FrequencyStatusReport) {
                            LoggerUtil.debug(TAG, statusReports[i].toString());
                        }
                    }
                }
            }
        }

        static class TagReadExceptionReceiver implements ReadExceptionListener {
            public void tagReadException(Reader r, ReaderException re) {
                if (re.getMessage().contains("The module has detected high return loss")
                        || re.getMessage().contains("Tag ID buffer full")
                        || re.getMessage().contains("No tags found")) {
                    // exception = "No connected antennas found";
                    /* Continue reading */
                    LoggerUtil.warn(TAG, "Waring exception: ", re);
                } else {
                    LoggerUtil.error(TAG, "Reader exception : ", re);
                    exception.add(re.getMessage());
                    exceptionOccur = true;
                    readThread.setReading(false);
                    readThread.publishProgress(-1);
                }
            }
        }

        private void refreshReadRate() {
            timer = new Timer();
            timer.schedule(new TimerTask() {
                @Override
                public void run() {
                    publishProgress(0);
                }
            }, 100, 100);
        }

        private void parseTag(TagReadData tr) {
            currentTagCount += tr.getReadCount();
            totalTagCount += tr.getReadCount();
            String epcString = tr.getTag().epcString();
//            Log.d(TAG, String.format("parseTag: %d read count, epc='%s'", tr.getReadCount(), tr.getTag().epcString()));
            if (tr.getReadCount() > 0) {
                beeper.beep();
            }
            if (epcToReadDataMap.keySet().contains(epcString)) {
                TagRecord tempTR = epcToReadDataMap.get(epcString);
                tempTR.setRssi(tr.getRssi());
                tempTR.readCount += tr.getReadCount();
            } else {
                TagRecord tagRecord = new TagRecord();
                tagRecord.setEpcString(epcString);
                tagRecord.setReadCount(tr.getReadCount());
                tagRecord.setRssi(tr.getRssi());
                epcToReadDataMap.put(epcString, tagRecord);
            }
        }

        @Override
        protected void onProgressUpdate(Integer... progress) {
            int progressToken = progress[0];
            if (progressToken == -1) {
                errorMsgView.setTextColor(redColor);
                StringBuilder sb = new StringBuilder("ERROR :");
                for (String exMsg : exception) {
                    sb.append("\n");
                    sb.append(exMsg);
                }
                temp_str = sb.toString();
                errorMsgView.setVisibility(View.VISIBLE);
                errorMsgView.setText(temp_str);

                if (++readLoop >= 100 || !isReading()) {
                    readLoop = 0;
                }
            } else {
                populateSearchResult(epcToReadDataMap);
                if (!exceptionOccur) {
                    searchResultCount.setTextColor(textColor);
                    if (crcCount == 0) {
                        searchResultCount.setText(Html.fromHtml("<b>Unique Tags :</b> " + epcToReadDataMap.keySet().size()));
                    } else {
                        searchResultCount.setText(Html.fromHtml("<b>CRC : " + crcCount + " Unique Tags :</b> " + epcToReadDataMap.keySet().size()));
                    }
                    totalTagCountView.setText(Html.fromHtml("<b>Total Tags  :</b> " + totalTagCount));

                    long elapsedTime = System.currentTimeMillis() - queryStartTime;
                    double timeTaken = ((double) elapsedTime / 1000);
                    temp_str = df.format(timeTaken) + " sec";
                    readingTimeView.setText(Html.fromHtml("<b>Time:</b> " + temp_str));
                    avg_str = df.format(totalTagCount / timeTaken);
                    avgReadView.setText(Html.fromHtml("<b>Avg. Reads Rate:</b> " + avg_str));

                    // Update temperature
                    temperatureView.setText(Html.fromHtml("<b>Temperature:</b> " + Temperature));

                    if (++readLoop >= 100) {
                        LoggerUtil.info(TAG, String.format("Unique Tags: %d, Total Tags: %d, Time: %s, Avg. Reads Rate: %s",
                                epcToReadDataMap.keySet().size(),
                                totalTagCount,
                                temp_str,
                                avg_str
                        ));
                        readLoop = 0;
                    }
                }
            }
        }

        @Override
        protected void onPostExecute(ConcurrentHashMap<String, TagRecord> epcToReadDataMap) {
            timer.cancel();
            String temp_str;
            if (exceptionOccur) {
                crcCount++;
                errorMsgView.setTextColor(redColor);
                StringBuilder sb = new StringBuilder("ERROR :");
                for (String exMsg : exception) {
                    sb.append("\n");
                    sb.append(exMsg);
                }
                temp_str = sb.toString();
                errorMsgView.setText(temp_str);
                totalTagCountView.setText("");
                if (totalTagCount > 0 && !operation.equalsIgnoreCase("syncRead")) {
                    totalTagCountView.setText(Html.fromHtml("<b>Total Tags  :</b> " + totalTagCount));
                }
            } else {
                if (crcCount == 0) {
                    searchResultCount.setText(Html.fromHtml("<b>Unique Tags :</b> " + epcToReadDataMap.keySet().size()));
                } else {
                    searchResultCount.setText(Html.fromHtml("<b>CRC : " + crcCount + " Unique Tags :</b> " + epcToReadDataMap.keySet().size()));
                }

                totalTagCountView.setText(Html.fromHtml("<b>Total Tags  :</b> " + totalTagCount));
                populateSearchResult(epcToReadDataMap);

                long elapsedTime = queryStopTime - queryStartTime;
                double timeTaken = ((double) elapsedTime / 1000);
                temp_str = df.format(timeTaken) + " sec";
                readingTimeView.setText(Html.fromHtml("<b>Time:</b> " + temp_str));
                avgReadView.setText(Html.fromHtml("<b>Avg. Reads Rate:</b> " + df.format(totalTagCount / timeTaken)));

                LoggerUtil.info(TAG, String.format("Unique Tags: %d, Total Tags: %d, Time: %s, Avg. Reads Rate: %s",
                        epcToReadDataMap.keySet().size(),
                        totalTagCount,
                        temp_str,
                        df.format(totalTagCount / timeTaken)
                ));
            }

            if (exceptionOccur && !exception.isEmpty() && !exception.get(exception.size() - 1).equalsIgnoreCase("No connected antennas found")) {
                disconnectReader();
                mReaderActivity.enableBarcode();
            } else {
                beeper.stopAllBeep();
                mReaderActivity.enableBarcode();

                readButton.setText(mReaderActivity.getResources().getString(R.string.start_reading));

                readButton.setClickable(true);
                readButton.setEnabled(true);

                connectButton.setClickable(true);
                connectButton.setEnabled(true);
            }
            setRunning(false);
            stopLock.lock();
            stopCondition.signalAll();
            stopLock.unlock();
        }

        private static void disconnectReader() {
            connectButton.setText(mReaderActivity.getResources().getString(R.string.Connect));
            connectButton.setEnabled(true);
            connectButton.setClickable(true);

            readButton.setText(mReaderActivity.getResources().getString(R.string.start_reading));
            readButton.setClickable(false);
            readButton.setEnabled(false);

            readcontrollayout.setVisibility(View.GONE);
            layout_firmware.setVisibility(View.GONE);
            firmware_hint.setVisibility(View.VISIBLE);

            mReaderActivity.reader.destroy();
            mReaderActivity.reader = null;

            mReaderActivity.PA760RFIDModulePowerCtrl(false);
            mReaderActivity.PA760RFIDModulePowerCtrl(true);

            if (!exceptionOccur) {
                searchResultCount.setText("");
                avgReadView.setText("");
                readingTimeView.setText("");
                temperatureView.setText("");
            }
            beeper.stopAllBeep();
        }

        @SuppressLint("InflateParams")
        private static void populateSearchResult(ConcurrentHashMap<String, TagRecord> epcToReadDataMap) {
            try {
                Set<String> keySet = epcToReadDataMap.keySet();
                for (String epcString : keySet) {
                    final TagRecord tagRecordData = epcToReadDataMap.get(epcString);

                    if (!addedEPCRecords.contains(epcString)) {
                        addedEPCRecords.add(epcString);
                        uniqueRecordCount = addedEPCRecords.size();
                        if (inflater != null) {
                            fullRow = (TableRow) inflater.inflate(R.layout.row, null, true);
                            fullRow.setClickable(true);
                            fullRow.setId(uniqueRecordCount);

                            if (fullRow != null) {
                                nr = (TextView) fullRow.findViewById(R.id.nr);

                                if (nr != null) {
                                    nr.setText(String.valueOf(uniqueRecordCount));
                                    nr.setWidth(mReaderActivity.rowNumberWidth);
                                    epcValue = (TextView) fullRow.findViewById(R.id.EPC);

                                    if (epcValue != null) {
                                        epcValue.setOnClickListener(new OnClickListener() {
                                            @Override
                                            public void onClick(View v) {
                                                EPCtag = tagRecordData.getEpcString();
                                                edt_epc.setText(EPCtag);
                                            }
                                        });
                                        epcValue.setText(tagRecordData.getEpcString());
                                        epcValue.setWidth(mReaderActivity.epcDataWidth);
                                        rssiView = (TextView) fullRow.findViewById(R.id.RSSI);
                                        if (rssiView != null) {
                                            rssiView.setText(String.valueOf(tagRecordData.getRssi()));
                                            rssiView.setWidth(mReaderActivity.epcRSSIWidth);
                                        }
                                        countView = (TextView) fullRow.findViewById(R.id.COUNT);
                                        if (countView != null) {
                                            countView.setText(String.valueOf(tagRecordData.getReadCount()));
                                            countView.setWidth(mReaderActivity.epcCountWidth);
                                        }
                                        if (isEmbeddedRead) {
                                            dataView = (TextView) fullRow.findViewById(R.id.DATA);
                                            if (dataView != null) {
                                                dataView.setVisibility(View.VISIBLE);
                                                dataView.setText(Arrays.toString(tagRecordData.getData()));
                                            }
                                        }
                                        table.addView(fullRow);
                                    }
                                }
                            }
                        }
                    } else {
                        fullRow = (TableRow) table.getChildAt(addedEPCRecords.indexOf(epcString));
                        if (fullRow != null) {
                            rssiView = (TextView) fullRow.getChildAt(2);
                            if (rssiView != null && Integer.valueOf(rssiView.getText().toString()) != tagRecordData.getRssi()) {
                                rssiView.setText(String.valueOf(tagRecordData.getRssi()));
                            }
                            countView = (TextView) fullRow.getChildAt(4);
                            if (countView != null && Integer.valueOf(countView.getText().toString()) != tagRecordData.getReadCount()) {
                                countView.setText(String.valueOf(tagRecordData.getReadCount()));
                            }
                        }
                    }
                }
            } catch (Exception ex) {
                LoggerUtil.error(TAG, "Exception while populating tags :", ex);
            }
        }

        public static boolean isReading() {
            return reading;
        }

        private void setReading(boolean reading) {
            ReadThread.reading = reading;
        }

        public static boolean isRunning() {
            return running;
        }

        private static synchronized void setRunning(boolean r) {
            running = r;
        }

        public static void setTemperature(int temp) {
            Temperature = temp;
        }
    }
}